Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# CLerpNodePathInterval Class Reference

An interval that lerps one or more properties (like pos, hpr, etc.) on a NodePath over time. More...

Inheritance diagram for CLerpNodePathInterval:

List of all members.

## Public Member Functions
| CLerpNodePathInterval (string name, double duration, BlendType blend_type, bool bake_in_start, bool fluid, NodePath const node, NodePath const other)
| Constructs a lerp interval that will lerp some properties on the indicated node, possibly relative to the indicated other node (if other is nonempty).
NodePath const | getNode ()
| Returns the node being lerped.
NodePath const | getOther ()
| Returns the "other" node, which the lerped node is being moved relative to.
int | getOverride ()
| Returns the override value that will be associated with any state changes applied by the lerp.
| setEndColor (VBase4 const color)
| Indicates that the color of the node should be lerped, and specifies the final color of the node.
| setEndColorScale (VBase4 const color_scale)
| Indicates that the color scale of the node should be lerped, and specifies the final color scale of the node.
| setEndHpr (VBase3 const hpr)
| Indicates that the rotation of the node should be lerped, and specifies the final rotation of the node.
| setEndHpr (Quat const quat)
| Indicates that the rotation of the node should be lerped, and specifies the final rotation of the node.
| setEndPos (VBase3 const pos)
| Indicates that the position of the node should be lerped, and specifies the final position of the node.
| setEndQuat (Quat const quat)
| Indicates that the rotation of the node should be lerped, and specifies the final rotation of the node.
| setEndQuat (VBase3 const hpr)
| Indicates that the rotation of the node should be lerped, and specifies the final rotation of the node.
| setEndScale (float scale)
| Indicates that the scale of the node should be lerped, and specifies the final scale of the node.
| setEndScale (VBase3 const scale)
| Indicates that the scale of the node should be lerped, and specifies the final scale of the node.
| setEndShear (VBase3 const shear)
| Indicates that the shear of the node should be lerped, and specifies the final shear of the node.
| setEndTexOffset (VBase2 const tex_offset)
| Indicates that the UV offset of the node should be lerped, and specifies the final UV offset of the node.
| setEndTexRotate (float tex_rotate)
| Indicates that the UV rotate of the node should be lerped, and specifies the final UV rotate of the node.
| setEndTexScale (VBase2 const tex_scale)
| Indicates that the UV scale of the node should be lerped, and specifies the final UV scale of the node.
| setOverride (int override)
| Changes the override value that will be associated with any state changes applied by the lerp.
| setStartColor (VBase4 const color)
| Indicates the initial color of the lerped node.
| setStartColorScale (VBase4 const color_scale)
| Indicates the initial color scale of the lerped node.
| setStartHpr (VBase3 const hpr)
| Indicates the initial rotation of the lerped node.
| setStartPos (VBase3 const pos)
| Indicates the initial position of the lerped node.
| setStartQuat (Quat const quat)
| Indicates the initial rotation of the lerped node.
| setStartScale (float scale)
| Indicates the initial scale of the lerped node.
| setStartScale (VBase3 const scale)
| Indicates the initial scale of the lerped node.
| setStartShear (VBase3 const shear)
| Indicates the initial shear of the lerped node.
| setStartTexOffset (VBase2 const tex_offset)
| Indicates the initial UV offset of the lerped node.
| setStartTexRotate (float tex_rotate)
| Indicates the initial UV rotate of the lerped node.
| setStartTexScale (VBase2 const tex_scale)
| Indicates the initial UV scale of the lerped node.
| setTextureStage (TextureStage stage)
| Indicates the texture stage that is adjusted by tex_offset, tex_rotate, and/or tex_scale.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

An interval that lerps one or more properties (like pos, hpr, etc.) on a NodePath over time.

## Constructor & Destructor Documentation

CLerpNodePathInterval | ( | string | name,
|  | double | duration,
|  | BlendType | blend_type,
|  | bool | bake_in_start,
|  | bool | fluid,
|  | NodePath const | node,
|  | NodePath const | other
| ) |  |

Constructs a lerp interval that will lerp some properties on the indicated node, possibly relative to the indicated other node (if other is nonempty).

You must call set_end_pos(), etc. for the various properties you wish to lerp before the first call to priv_initialize(). If you want to set a starting value for any of the properties, you may call set_start_pos(), etc.; otherwise, the starting value is taken from the actual node's value at the time the lerp is performed.

The starting values may be explicitly specified or omitted. The value of bake_in_start determines the behavior if the starting values are omitted. If bake_in_start is true, the values are obtained the first time the lerp runs, and thenceforth are stored within the interval. If bake_in_start is false, the starting value is computed each frame, based on assuming the current value represents the value set from the last time the interval was run. This "smart" behavior allows code to manipulate the object event while it is being lerped, and the lerp continues to apply in a sensible way.

If fluid is true, the prev_transform is not adjusted by the lerp; otherwise, it is reset.

## Member Function Documentation

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from CLerpInterval.

NodePath const getNode | ( |  | ) |

Returns the node being lerped.

NodePath const getOther | ( |  | ) |

Returns the "other" node, which the lerped node is being moved relative to.

If this is an empty node path, the lerped node is being moved in its own coordinate system.

int getOverride | ( |  | ) |

Returns the override value that will be associated with any state changes applied by the lerp.

See set_override().

setEndColor | ( | VBase4 const | color | ) |

Indicates that the color of the node should be lerped, and specifies the final color of the node.

This should be called before priv_initialize(). If this is not called, the node's color will not be affected by the lerp.

setEndColorScale | ( | VBase4 const | color_scale | ) |

Indicates that the color scale of the node should be lerped, and specifies the final color scale of the node.

This should be called before priv_initialize(). If this is not called, the node's color scale will not be affected by the lerp.

setEndHpr | ( | VBase3 const | hpr | ) |

Indicates that the rotation of the node should be lerped, and specifies the final rotation of the node.

This should be called before priv_initialize().

This replaces a previous call to set_end_quat(). If neither set_end_hpr() nor set_end_quat() is called, the node's rotation will not be affected by the lerp.

setEndHpr | ( | Quat const | quat | ) |

Indicates that the rotation of the node should be lerped, and specifies the final rotation of the node.

This should be called before priv_initialize().

This special function is overloaded to accept a quaternion, even though the function name is set_end_hpr(). The quaternion will be implicitly converted to a HPR trio, and the lerp will be performed in HPR space, componentwise.

setEndPos | ( | VBase3 const | pos | ) |

Indicates that the position of the node should be lerped, and specifies the final position of the node.

This should be called before priv_initialize(). If this is not called, the node's position will not be affected by the lerp.

setEndQuat | ( | Quat const | quat | ) |

Indicates that the rotation of the node should be lerped, and specifies the final rotation of the node.

This should be called before priv_initialize().

This replaces a previous call to set_end_hpr(). If neither set_end_quat() nor set_end_hpr() is called, the node's rotation will not be affected by the lerp.

setEndQuat | ( | VBase3 const | hpr | ) |

Indicates that the rotation of the node should be lerped, and specifies the final rotation of the node.

This should be called before priv_initialize().

This replaces a previous call to set_end_hpr(). If neither set_end_quat() nor set_end_hpr() is called, the node's rotation will not be affected by the lerp.

This special function is overloaded to accept a HPR trio, even though the function name is set_end_quat(). The HPR will be implicitly converted to a quaternion, and the lerp will be performed in quaternion space, as a spherical lerp.

setEndScale | ( | VBase3 const | scale | ) |

Indicates that the scale of the node should be lerped, and specifies the final scale of the node.

This should be called before priv_initialize(). If this is not called, the node's scale will not be affected by the lerp.

setEndScale | ( | float | scale | ) |

Indicates that the scale of the node should be lerped, and specifies the final scale of the node.

This should be called before priv_initialize(). If this is not called, the node's scale will not be affected by the lerp.

setEndShear | ( | VBase3 const | shear | ) |

Indicates that the shear of the node should be lerped, and specifies the final shear of the node.

This should be called before priv_initialize(). If this is not called, the node's shear will not be affected by the lerp.

setEndTexOffset | ( | VBase2 const | tex_offset | ) |

Indicates that the UV offset of the node should be lerped, and specifies the final UV offset of the node.

This should be called before priv_initialize(). If this is not called, the node's UV offset will not be affected by the lerp.

setEndTexRotate | ( | float | tex_rotate | ) |

Indicates that the UV rotate of the node should be lerped, and specifies the final UV rotate of the node.

This should be called before priv_initialize(). If this is not called, the node's UV rotate will not be affected by the lerp.

setEndTexScale | ( | VBase2 const | tex_scale | ) |

Indicates that the UV scale of the node should be lerped, and specifies the final UV scale of the node.

This should be called before priv_initialize(). If this is not called, the node's UV scale will not be affected by the lerp.

setOverride | ( | int | override | ) |

Changes the override value that will be associated with any state changes applied by the lerp.

If this lerp is changing state (for instance, a color lerp or a tex matrix lerp), then the new attributes created by this lerp will be assigned the indicated override value when they are applied to the node.

setStartColor | ( | VBase4 const | color | ) |

Indicates the initial color of the lerped node.

This is meaningful only if set_end_color() is also called. This parameter is optional; if unspecified, the value will be taken from the node's actual color at the time the lerp is performed.

setStartColorScale | ( | VBase4 const | color_scale | ) |

Indicates the initial color scale of the lerped node.

This is meaningful only if set_end_color_scale() is also called. This parameter is optional; if unspecified, the value will be taken from the node's actual color scale at the time the lerp is performed.

setStartHpr | ( | VBase3 const | hpr | ) |

Indicates the initial rotation of the lerped node.

This is meaningful only if either set_end_hpr() or set_end_quat() is also called. This parameter is optional; if unspecified, the value will be taken from the node's actual rotation at the time the lerp is performed.

setStartPos | ( | VBase3 const | pos | ) |

Indicates the initial position of the lerped node.

This is meaningful only if set_end_pos() is also called. This parameter is optional; if unspecified, the value will be taken from the node's actual position at the time the lerp is performed.

setStartQuat | ( | Quat const | quat | ) |

Indicates the initial rotation of the lerped node.

This is meaningful only if either set_end_quat() or set_end_hpr() is also called. This parameter is optional; if unspecified, the value will be taken from the node's actual rotation at the time the lerp is performed.

setStartScale | ( | VBase3 const | scale | ) |

Indicates the initial scale of the lerped node.

This is meaningful only if set_end_scale() is also called. This parameter is optional; if unspecified, the value will be taken from the node's actual scale at the time the lerp is performed.

setStartScale | ( | float | scale | ) |

Indicates the initial scale of the lerped node.

This is meaningful only if set_end_scale() is also called. This parameter is optional; if unspecified, the value will be taken from the node's actual scale at the time the lerp is performed.

setStartShear | ( | VBase3 const | shear | ) |

Indicates the initial shear of the lerped node.

This is meaningful only if set_end_shear() is also called. This parameter is optional; if unspecified, the value will be taken from the node's actual shear at the time the lerp is performed.

setStartTexOffset | ( | VBase2 const | tex_offset | ) |

Indicates the initial UV offset of the lerped node.

This is meaningful only if set_end_tex_offset() is also called. This parameter is optional; if unspecified, the value will be taken from the node's actual UV offset at the time the lerp is performed.

setStartTexRotate | ( | float | tex_rotate | ) |

Indicates the initial UV rotate of the lerped node.

This is meaningful only if set_end_tex_rotate() is also called. This parameter is optional; if unspecified, the value will be taken from the node's actual UV rotate at the time the lerp is performed.

setStartTexScale | ( | VBase2 const | tex_scale | ) |

Indicates the initial UV scale of the lerped node.

This is meaningful only if set_end_tex_scale() is also called. This parameter is optional; if unspecified, the value will be taken from the node's actual UV scale at the time the lerp is performed.

setTextureStage | ( | TextureStage | stage | ) |

Indicates the texture stage that is adjusted by tex_offset, tex_rotate, and/or tex_scale.

If this is not set, the default is the default texture stage.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties